﻿Imports System.Data.SqlClient

Partial Class VB
    Inherits System.Web.UI.Page
    Protected Sub Page_Load(ByVal sender As Object, ByVal e As EventArgs) Handles Me.Load
        If Not Me.IsPostBack Then
            Dim query As String = "SELECT CountryId, CountryName FROM Countries"
            Me.BindDropDownList(ddlCountries, query, "CountryName", "CountryId", "Select Country")
            ddlStates.Enabled = False
            ddlCities.Enabled = False
            ddlStates.Items.Insert(0, New ListItem("Select State", "0"))
            ddlCities.Items.Insert(0, New ListItem("Select City", "0"))
        End If
    End Sub

    Private Sub BindDropDownList(ByVal ddl As DropDownList, ByVal query As String, ByVal text As String, ByVal value As String, ByVal defaultText As String)
        Dim constr As String = ConfigurationManager.ConnectionStrings("constr").ConnectionString
        Using con As SqlConnection = New SqlConnection(constr)
            Using cmd As SqlCommand = New SqlCommand(query, con)
                con.Open()
                ddl.DataSource = cmd.ExecuteReader()
                ddl.DataTextField = text
                ddl.DataValueField = value
                ddl.DataBind()
                con.Close()
            End Using
        End Using
        ddl.Items.Insert(0, New ListItem(defaultText, "0"))
    End Sub

    Protected Sub Country_Changed(ByVal sender As Object, ByVal e As EventArgs)
        Dim countryId As Integer = Integer.Parse(ddlCountries.SelectedItem.Value)
        If countryId > 0 Then
            Dim query As String = String.Format("SELECT StateId, StateName FROM States WHERE CountryId = {0}", countryId)
            Me.BindDropDownList(ddlStates, query, "StateName", "StateId", "Select State")
            ddlStates.Enabled = True
        End If
    End Sub

    Protected Sub State_Changed(ByVal sender As Object, ByVal e As EventArgs)
        Dim stateId As Integer = Integer.Parse(ddlStates.SelectedItem.Value)
        If stateId > 0 Then
            Dim query As String = String.Format("SELECT CityId, CityName FROM Cities WHERE StateId = {0}", stateId)
            Me.BindDropDownList(ddlCities, query, "CityName", "CityId", "Select City")
            ddlCities.Enabled = True
        End If
    End Sub

    Protected Sub City_Changed(ByVal sender As Object, ByVal e As EventArgs)
        ClientScript.RegisterStartupScript(Me.GetType(), "alert", "alert('Country: " & ddlCountries.SelectedItem.Text &
                                            "\nState: " + ddlStates.SelectedItem.Text &
                                            "\nCity: " + ddlCities.SelectedItem.Text & "');", True)
        ddlStates.Enabled = False
        ddlCities.Enabled = False
        ddlCountries.SelectedIndex = 0
    End Sub
End Class

